<?php
/*
#####################################################################
#                      PHP Source Code Utility                      #
#              Line Numberer and Syntax Highlighter                 #
#                           Version 1.0.0                           #
#                 2002 0php.com - Free PHP Scripts                 #
#####################################################################

#####################################################################
#                                                                   #
#  Author      :  Mike Miller                                       #
#  Date        :  July 13, 2002                                     #
#  E-mail      :  webmaster@0php.com                                #
#  Website     :  http://www.0php.com/                              #
#  License     :  FREE (GPL);  See Copyright and Terms below        #
#                                                                   #
#        Donations accepted via PayPal to webmaster@0php.com        #
#                                                                   #
#####################################################################


>> Summary:

Highlight PHP syntax and optionally add line numbers to PHP source code or files,
with several output options.  Files to highlight are chosen in a form and temporarily
uploaded to the remote server, or you can use this script on your local server.


>> Copyright and Terms:

This software is copyright (C) 2002 Mike Miller.  It is distributed
under the terms of the GNU General Public License (GPL).  Because it is licensed
free of charge, there is NO WARRANTY, it is provided AS IS.  The author can not
be held liable for any damage that might arise from the use of this software.
Use it at your own risk.

All copyright notices and links to 0PHP.com website MUST remain intact in the scripts and in the HTML for the scripts.

For more details, see http://www.0php.com/license_GNU_GPL.php (or http://www.gnu.org/).


>> SPECIAL NOTES:

(1) Be careful of displaying passwords and private data in the source being seen.
(2) If line numbers are joined to the source, the syntax is not highlighted.
(3) Default values below can be easily modified.
(4) This file will work if renamed.  Perhaps Source Code Utility Manger, or its abbreviation, scum.php, would we easier to remember :o) .


>> Tested on:
Windows 98     - PHP Version 4.0.1pl2
Windows NT 5.1 - PHP Version 4.1.2
Linux          - PHP Version 4.0.3pl1


#####################################################################
Default values below can be modified - optional
#####################################################################
*/


$max_size=200000;           # MAX_FILE_SIZE in bytes for file upload;
                            #    also limited by PHP settings variable: upload_max_filesize
$extensions="php,htm,inc";  # extensions allowed if begin with these; separated by comma only

ini_set("highlight.bg",      "#FFFFFF");    # white
ini_set("highlight.comment", "#FF8000");    # orange
ini_set("highlight.default", "#0000BB");    # blue
ini_set("highlight.html",    "#000000");    # black
ini_set("highlight.keyword", "#007700");    # green
ini_set("highlight.string",  "#DD0000");    # red



### No need to modify below here ############################################################


error_reporting(0);

$max_size_ini = ini_get("upload_max_filesize");
$max_size_ini = (int) $max_size_ini;  # remove M at end

$ext="(\." . str_replace (",", "|\.", $extensions) . ")";     # $ext="(\.php|\.htm|\.inc)";

if(!isset($Add_Line_Numbers)) $Add_Line_Numbers = "Separate";
if(!isset($ShowForm)) $ShowForm = "No";
if(!isset($file)) $ShowForm = "Yes";

echo<<<endHTML
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<HTML><HEAD>
<TITLE>0PHP.com PHP Source Code Utility - Line Numberer and Syntax Highlighter</TITLE>
<meta http-equiv="Content-Type" content="text/html; charset=windows-1252">
<META HTTP-EQUIV="Content-Language" CONTENT="en-us">
<meta http-equiv="Content-Style-Type" content="text/css">
<STYLE type="text/css">
  A:hover   { COLOR: #FF0000; TEXT-DECORATION: underline}
</STYLE>
</HEAD>
<BODY BGCOLOR="white" link="navy" vlink="navy" alink="navy">

endHTML;


if ($ShowForm=="Yes")
{
echo<<<endHTML


<div align="center"><center>
<table border="0" cellpadding="0" cellspacing="0"><tr><td>

<font face="Arial"><p align="center"><font size="+2"><b>PHP Source Code Utility<br>Line Numberer and Syntax Highlighter</b></font></p>

endHTML;

echo "<form enctype = \"multipart/form-data\" action = \"$PHP_SELF\" method = \"post\">";

echo<<<endHTML

<INPUT TYPE="hidden" name="MAX_FILE_SIZE" value="20000">
Upload (filename and path): &nbsp;
<input type = "file" name = "file" size="30">
<p>Line Numbers:&nbsp; <select size="1" name="Add_Line_Numbers">
  <option>None</option>
  <option selected>Separate</option>
  <option>Joined</option>
</select>&nbsp; 
Redisplay this form at top:&nbsp; 
<input type="checkbox" name="ShowForm" value="Yes"><br>
<input type="reset" value="Reset">&nbsp; 
<input type = "submit" value = "Submit">
</form><br></font>

</td></tr>
</table>
</center></div>

<hr>

endHTML;
}




if (isset($file))                       # is there a file to process?
{
if($file=="none" || $file_size<1)
{
echo "<H2><font face=\"Arial\"><font color=red>ERROR:</font> Max file size of $max_size_ini bytes exceeded, or file error!</font></H2><br>\n";
echo "<font face=\"Arial\" size=\"+1\"><a href=$PHP_SELF>Highlight source code another file</a><br><br><font>";
}
else
{
if (eregi($ext,$file_name))             # check file extension okay
{                                       # file is all okay - process it


$fcontents = file($file);
$nlines=count($fcontents);
$nlines2=number_format($nlines);
$nchars=number_format(strlen(join('',$fcontents)));

# print file name and info at top
if ($file_size < 1000) $size_txt = "Bytes";
else { $file_size = $file_size / 1000; $size_txt = "KB"; }

$last_modified=date("M d, Y - h:i:s A", filemtime("$file"));  # or now = time()

echo "
<p align=\"center\"><font face=\"Verdana\">
<font size=\"+2\">PHP Source Code of: '<font color=\"#FF0000\">$file_name</font>'<br>
</font><font size=1>Date: <font color=\"#FF0000\">$last_modified</font><br>
Size: 
<font color=\"#FF0000\">$file_size $size_txt</font>&nbsp; |&nbsp; 
<font color=\"#FF0000\">$nlines2 lines</font>&nbsp; |&nbsp; 
<font color=\"#FF0000\">$nchars characters</font></font></font>
<hr>\n\n
<div align=\"left\">\n<table border=0 cellpadding=10 cellspacing=0><tr>\n<td nowrap>\n
";

	$digits=1;                               # need to even lines
	if ($nlines>=10) $digits=2;
	if ($nlines>=100) $digits=3;
	if ($nlines>=1000) $digits=4;
	if ($nlines>=10000) $digits=5;


if ($Add_Line_Numbers == "None")
{
	echo "\n<!----------- begin source code ----------->\n\n\n";
	show_source($file);
	echo "\n\n\n<!----------- end source code ----------->\n\n\n";
}

elseif ($Add_Line_Numbers == "Joined")
{
	echo "\n\n<code>\n";
	while (list ($line_num, $line) = each ($fcontents))
	{
	$line_num++;
	$line_num=str_pad("$line_num", $digits, " ");
	$line_num=str_replace(' ','&nbsp;',htmlspecialchars($line_num));
	$line = str_replace(' ','&nbsp;',htmlspecialchars($line));
	echo "<b>Line $line_num:</b>&nbsp; " . $line . "<br>\n";
	}
		echo "</code>\n\n";
}


else          # $Add_Line_Numbers == "Separate"
{
# show line numbers in left table cell

echo "<code><b>\n";
while (list($line_num, $line) = each ($fcontents))
{
	$line_num++;
	$line_num=str_pad("$line_num", $digits, " ");
	$line_num=str_replace(' ','&nbsp;',htmlspecialchars($line_num));
	echo "Line $line_num:<br>\n";
}

echo "</b></code></td>\n<td nowrap>\n\n";
echo "\n<!----------- begin source code ----------->\n\n\n";

# show source in right table cell
show_source($file);

echo "\n\n\n<!----------- end source code ----------->\n\n\n";

}


echo "</td></tr>\n</table></div>\n<hr>\n";



# end ifs for checking if file okay to process
} else {
echo "<H2><font face=\"Arial\"><font color=red>ERROR:</font> Only files with extensions beginning with $extensions are allowed!</font></H2><br>\n"; 
}}}

?>


<p align="center"><font face="Verdana" size=1>PHP Source Code Utility - Version 1.0.0<br>
<a href="http://www.0php.com">Free PHP Scripts</a> - Copyright  <a href="http://www.0php.com">0php.com</a> 2002.</font>

</BODY></HTML>
